<template>
    <div
        v-if="shop"
        class="text-center"
    >
        <div class="broadcast-preview push">
            <div class="push-notification-container">
                <div class="notification-img">
                    <img
                        id="img-preview"
                        :src="textEditor.picture"
                        alt=""
                        class="notification-img-block"
                    >
                </div>
                <div class="notification-content">
                    <h3
                        class="title"
                        v-html="replaceText(textEditor.title)"
                    />
                    <p
                        class="subtitle"
                        v-html="replaceText(textEditor.text)"
                    />
                    <a
                        href="#"
                        class="carti-link"
                    >
                        <span>{{ getDomainName(textEditor.url) }}</span>
                    </a>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import shop from '../../../mixins/shop.service'
import campaigns from '../../../mixins/push/campaigns.service'

export default {
    name: "PushCampaignPreview",
    mixins: [shop, campaigns],
    props: ['textEditor'],
    data() {
        return {
            shop: null,
            isShopify: false,
            image: '',
            code: Math.random().toString(36).slice(2, 8).toUpperCase(),
        }
    },
    mounted() {
        this.loadShop()
        if ($cookies.get('platform') === 'shopify') {
            this.isShopify = true
        }
        this.loadImage()
    },
    methods: {
        async loadImage() {
            const response = await this.getPicture(this.$route.params.id)
        },
        async loadShop() {
            const response = await this.getShop()
            this.shop = response
            if(!this.textEditor.url) this.textEditor.url = this.shop.site_url
        },
        getDomainName(url) {
            return url.replace('http://', '').replace('https://', '').replace('www.', '').split(/[/?#]/)[0];
        },
        replaceText(text) {
            if (!text) {
                text = ''
            }
            text = text.replace(/{domain}/g, `<a href="#">` + (this.shop.site_url ? this.shop.site_url : 'Shop URL') + '</a>')
                .replace(/{firstName}/g, 'John')
                .replace(/{lastName}/g, 'Doe')
                .replace(/{siteName}/g, this.shop.custom_name || this.shop.site_name)
                .replace(/{campaignLink}/g, `<a href="#">`)
                .replace(/{\/campaignLink}/g, '</a>')
                .replace(/{unsubscribeLink}/g, `<a href="#">`)
                .replace(/{\/unsubscribeLink}/g, '</a>')
                .replace(/{discountValue}/g, this.textEditor.automatic_discount_value)
                .replace(/{discountCode}/g, this.textEditor.automatic_discount_enabled == false ? this.textEditor.code : this.code)
                .replace(/{storeEmail}/g,  this.shop.custom_email || this.shop.email || 'Email');

            return text;
        }
    }
}
</script>

<style scoped lang="scss">

.text-center {
    margin-top: 25px;
}

.push-notification-container {
    display: inline-flex;
    width: 100%;
    max-width: 360px;
    height: auto;
    border: 1px solid #f0f0f0;
    padding: 10px;
    box-shadow: 0 3px 3px rgb(0 0 0 / 20%);
    background: #ffffff;
    text-align: left;

    .notification-img .notification-img-block {
        max-width: 85px;
        max-height: 85px;
    }

    .notification-content {
        display: flex;
        flex-direction: column;
        padding-left: 15px;
        position: relative;
    }

    h3 {
        font-size: 14px;
        margin: 0;
    }

    .subtitle {
        margin: 5px 0;
        font-size: 12px;
    }

    .carti-link {
        color: #888888;
        text-decoration: none;
        font-size: 12px;
    }
}

</style>
